#include <stdio.h>

int main(int argc, char *argv[])
{
  FILE *in, *out;
  char *outfilename;
  char *token;
  int total_bytes=0;

  if (argc != 4) {
    fprintf(stderr,"Usage: bin2s file.dat outfile.h token_name\n");
    return 1;
  }

  in = fopen(argv[1],"rb");

  if (!in) {
    fprintf(stderr,"Error: file not found\n");
    return 1;
  }
  out = fopen(argv[2],"wt");

  if (!out) {
    fclose(in);
    fprintf(stderr,"Error: could not open output file\n");
    return 1;
  }

  outfilename = argv[2];
  token = argv[3];

  fprintf(out, "//\n"
               "//   %s\n"
               "//\n"
               "//   This header file was dynamically generated by bin2h.exe \n"
               "//   and should not by modified by hand.\n"
               "//\n\n", outfilename);

  fprintf(out,"unsigned char %s[] = {  \n",token);
  for (;;) {
    static int firsttime;
    static int linecount;
    int c;
    if (++linecount > 10) {
      linecount = 0;
      fprintf(out,",\n  ");
    }
    else if (firsttime) fprintf(out,", ");
    firsttime = 1;
    c = fgetc(in);
    if (feof(in)) break;
    total_bytes++;
    fprintf(out,"%i",c);
  }
  fprintf(out,"};\n",token,total_bytes);
  fclose(in);
  fclose(out);

  fprintf(stderr,"   Building %s\n",outfilename);
  fprintf(stderr,"   Finished %s (%d bytes)\n\n",outfilename,total_bytes);

  return 0;
}
